#include "freelist_internal.h"





/****************************************************************************/
void freelist_delete( void *freelist_state, void (*user_data_delete_function)(void *user_data, void *user_state), void *user_state )
{
  struct freelist_state
    *fs;

  void
    *freelist_element,
    *user_data;

  assert( freelist_state != NULL );
  // user_data_delete_function can be NULL
  // user_state can be NULL

  fs = (struct freelist_state *) freelist_state;

  while( freelist_pop(freelist_state, &freelist_element) )
  {
    if( user_data_delete_function != NULL )
    {
      freelist_get_user_data_from_element( freelist_element, &user_data );
      user_data_delete_function( user_data, user_state );
    }

    abstraction_aligned_free( freelist_element );
  }

  abstraction_aligned_free( freelist_state );

  return;
}

